; tmr800.a51: July 2000 RIDE try of timer program
;  add ALE assertion (11/13)
;  amends 1998 try of timer: add troubleshoot view of timer values
; 8/31/98: try auto-reload, using timer2, 16-bit
; 9/2 try adding clear of overflow flag, when int does not occur

    $NOSYMBOLS        ; keeps listing short

; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC) 
	

	 CLRDCEN SET 07Fh		; mask to clear DCEN bit, for up count
	 DIV4 SET 20h			; single bit to set hi for prescale to "/4"
	 
	 HITIME SET 0FFh	; set start count close to the overflow val
	 LOTIME SET 0E0H	;  ...and this is the low byte


	ORG 0H

	AJMP STARTUP

	ORG 0C0h

STARTUP:	MOV 0C4h, #04h	; turn on ALE during ROM run (bit 2, ALEON, of PMR register, C4h)
    ACALL   INITS         ;GO INITIALIZE

	CLR A
	MOV RCAP2H, #HITIME		; Init timer registers (tiny count:
	MOV RCAP2L, #LOTIME		;  timer counts DOWN from initial value
	SETB TR2						; ...and enable timer 2

	
TEST:	MOVX @DPTR, A			; ...show INC'X value on displays
	SJMP TEST		; AWAIT INTERRUPTS, showing current 
				;  display value

;------------------------------
; ISR: JUST INCREMENT A
	ORG TIMER2VECTOR
;ISR:	INC R0
ISR:	INC A
	CLR TF2		; Clear timer-2 overflow flag, as defined
					;  among Dallas registers listed by Raisonance
					;  (reference as "T2CON.7" failed--didn't produce
					;  an error message, but also did not clear the bit)
	RETI	


; SUBROUTINE*******************************************
	ORG 0E0h
; SOME INITIALIZATIONS
INITS:	MOV DPTR, #8000h	; point to displays
;	ORL T2MOD,#2h				; Set T20E: let rollover toggle pin
;									;  rather than generate int
	ANL T2MOD,#CLRDCEN		; clear DCEN bit: sets counter to UP
									;  (reiterates default)
	ORL CKCON,#DIV4			; set timer-prescaler to faster--div by 4

; init timer registers for first pass (otherwise, VERY slow first pass!)	
	MOV TH2, #HITIME		; Init timer registers (tiny count:
	MOV TL2, #LOTIME		;  timer counts DOWN from initial value

	
; ----NOW ENABLE INTERRUPTS----
	SETB EA		; Global int enable
	SETB ET2		; timer-2 interrupt enable
	RET
	
	END
